#ifndef _segy_matlab_h_
#define _segy_matlab_h_

const char *segy_file_header_names[33] = {
  "TextHeader",
  "JobID",
  "LineNumber",
  "ReelNumber",
  "TracesPerRecord",            //
  "AuxTracesPerRecord",         //
  "ReelSampleInterval",         //
  "FieldSampleInterval",
  "ReelSamplesPerTrace",        //
  "FieldSamplesPerTrace",      
  "SampleFormatCode",           //
  "CDPFold",
  "TraceSortingCode",
  "VertSumCode",
  "StartSweepFreq",
  "EndSweepFreq",
  "SweepLength",
  "SweepCode",
  "SweepTraceNumber",
  "StartSweepTaperLength",
  "EndSweepTaperLength",
  "TaperType",
  "DataTracesCorrelated",
  "BinaryGainRecovered",
  "AmpRecoverMethod",
  "MeasurementSystem",          //
  "ImpulseSignalPolarity",
  "VibratoryPolarityCode",
  // <- End SEGY-0  Start SEGY1 ->
  "unassigned",
  "RevisionNumber",             //
  "FixedLengthTraceFlag",       //
  "ExtendedTextHeaders",        //
  "unassigned2"
};


const char *segy_trace_header_names[87] = {
  "LineSeqNumber",                //
  "ReelSeqNumber",
  "FieldRecordNumber",            //
  "TraceNumber",                  //
  "EnergySourceNumber",           
  "CDPEnsembleNumber",
  "CDPTraceNumber",
  "TraceCode",                  //
  "VertSumTraces",
  "HorizSumTraces",
  "DataUse",
  "SourceGroupDist",
  "GroupElevation",
  "SourceElevation",
  "SourceDepth",
  "GroupDatumElevation",
  "SourceDatumElevation",
  "SourceWaterDepth",
  "GroupWaterDepth",
  "ElevationScalar",
  "CoordinateScalar",
  "SourceX",
  "SourceY",
  "GroupX",
  "GroupY",
  "CoordinateUnit",
  "WeatheringVelocity",
  "SubweatheringVelocity",
  "SourceTime",
  "GroupTime",
  "SourceCorrection",
  "GroupCorrection",
  "TotalCorrection",
  "LagTimeA",
  "LagTimeB",
  "DelayAccordingTime",
  "BruteTime",
  "MuteTime",
  "SamplesPerTrace",            //
  "SampleInterval",             //
  "GainType",
  "GainConstant",
  "InitialGain",
  "Correlated",
  "StartSweepFreq",
  "EndSweepFreq",
  "SweepLength",
  "SweepType",
  "StartSweepTaperLength",
  "EndSweepTaperLength",
  "TaperType",
  "AliasFilterFreq",
  "AliasFilterSlope",
  "NotchFilterFreq",
  "NotchFilterSlope",
  "LowCutFreq",
  "HightCutFreq",
  "LowCutSlope",
  "HighCutSlope",
  "Year",
  "DayOfYear",
  "Hour",
  "Minute",
  "Second",
  "TimeCode",
  "TraceWeightFactor",
  "GroupRollNumber",
  "GroupTraceStart",
  "GroupTraceEnd",
  "GapSize",
  "Overtravel",
  // <- End SEGY-0  Start SEGY-1 ->
  "CDPEnsembleX",
  "CDPEnsembleY",
  "InLine",
  "CrossLine",
  "Shotpoint",
  "ShotpointScalar",
  "MeasurementUnit",
  "TransductionConstant",
  "TransductionUnit",
  "DeviceID",
  "TimeScalar",
  "SourceType",
  "SourceDirection",
  "SourceMeasurement",
  "SourceMeasurementUnit",
  "unassigned"
};


#endif
