#!/usr/bin/perl -w
use strict;

my @labels;
while (<STDIN>) {
    my $line = $_;
    if ($line =~ /^\s*(\w+)\s+(\w+);.*$/) {
      my ($type, $label) = $line =~ /^\s*(\w+)\s+(\w+);.*$/;
      if ($type =~ /int/) {
	  print "  $label = mxCreateNumericMatrix(1,1,mxINT32_CLASS,mxREAL);\n";
	  print "  if (mxGetData($label)) ((int*)mxGetData($label))[0] = header.$label;\n";
	  print "  mxSetField(out_argv[1], 0, \"$label\", $label);\n\n";
          $labels[@labels] = $label;
      }
      if ($type =~ /short/) {
	  print "  $label = mxCreateNumericMatrix(1,1,mxINT16_CLASS,mxREAL);\n";
	  print "  if (mxGetData($label)) ((short*)mxGetData($label))[0] = header.$label;\n";
	  print "  mxSetField(out_argv[1], 0, \"$label\", $label);\n\n";
	  $labels[@labels] = $label;
      }
  }
    elsif ($line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/) {
	my ($label, $size) = $line =~ /^\s*char\s+(\w+)\[(\d+)\];.*$/;
	print "  size[0] = 1; size[1] = $size;\n";
	print "  $label = mxCreateCharArray(2, size);\n";
	print "  if (! $label) mexErrMsgTxt(\"out of memory\");\n";
	print "  for (i=0; i<$size; i++) \n";
	print "    ((short*)mxGetPr($label))[i] = header.$label"."[i];\n";
	print "  mxSetField(out_argv[1], 0, \"$label\", $label);\n\n";
	$labels[@labels] = $label;
    }
      
    else {
	print "\n";
    }  
}

my $i = 0;
foreach my $lbl (@labels) {
    if (($i % 4) == 0) {
	if ($i != 0) { print ";"; }
	print "\n  mxArray *$lbl, ";
    }
    else {
	print "*$lbl";
	if (($i + 1) % 4) { print ", "; }
    }
    $i++;
}
