#include <stdio.h>
#include <stdlib.h>

// printbits(byte, buf, len)
//   byte: char   = a byte of data
//   buf : char * = string buffer
//   len : size_t = length of buf in characters
// prints string representation of byte to buf, up to len-1 characters 
void printbits(char byte, char *buf, size_t len)
{
  int val[8] = {0};
  val[0] = (byte & 0x01) ? 1 : 0;
  val[1] = (byte & 0x02) ? 1 : 0;
  val[2] = (byte & 0x04) ? 1 : 0;
  val[3] = (byte & 0x08) ? 1 : 0;
  val[4] = (byte & 0x10) ? 1 : 0;
  val[5] = (byte & 0x20) ? 1 : 0;
  val[6] = (byte & 0x40) ? 1 : 0;
  val[7] = (byte & 0x80) ? 1 : 0;
  snprintf(buf, len, "%d%d%d%d%d%d%d%d", val[7], val[6], val[5], val[4],
	   val[3], val[2], val[1], val[0]);
}

int main(int argc, char **argv)
{
  char *USAGE = "USAGE: printfloat float_number\n";
  if (argc < 2) {
    printf(USAGE);
    return 1;
  }

  float f = strtof(argv[1], NULL);
  char *bytes = (char*)&f;

  char bits[33] = {0};
  int i;
  for (i = 3; i >= 0; i--) printbits(bytes[i], bits + (8 * (3-i)), 9);
  printf("s exponent mantissa\n");

  // print sign bit
  printf("%c ", bits[0]);

  // print exponent bits
  for (i = 1; i < 9; i++) printf("%c", bits[i]);
  printf(" ");

  // print mantissa bits
  for (i = 9; i < 32; i++) {
    printf("%c", bits[i]);
    if ((i % 4) == 0) printf(" ");
  }
  printf("\n");

  return 0;
}
