#include <stdio.h>
#include <stdlib.h>

// printbits(byte, buf, len)
//   byte: char   = a byte of data
//   buf : char * = string buffer
//   len : size_t = length of buf in characters
// prints string representation of byte to buf, up to len-1 characters 
void printbits(char byte, char *buf, size_t len)
{
  int val[8] = {0};
  val[0] = (byte & 0x01) ? 1 : 0;
  val[1] = (byte & 0x02) ? 1 : 0;
  val[2] = (byte & 0x04) ? 1 : 0;
  val[3] = (byte & 0x08) ? 1 : 0;
  val[4] = (byte & 0x10) ? 1 : 0;
  val[5] = (byte & 0x20) ? 1 : 0;
  val[6] = (byte & 0x40) ? 1 : 0;
  val[7] = (byte & 0x80) ? 1 : 0;
  snprintf(buf, len, "%d%d%d%d%d%d%d%d", val[7], val[6], val[5], val[4],
	   val[3], val[2], val[1], val[0]);
}

int main(int argc, char **argv)
{
  char *USAGE = "USAGE: printint int_number\n";
  if (argc < 2) {
    printf(USAGE);
    return 1;
  }

  int num = atoi(argv[1]);
  char *bytes = (char*)&num;

  char bits[33] = {0};
  int i,j;
  for (i = 0; i < 4; i++) printbits(bytes[i], bits + (8 * i), 9);
  printf("num -> decimal(%d) , binary(", num);
  char byterep[9] = {0};
  for (i = 0; i < 4; i++) {
    for (j = 0; j < 8; j++) {
      byterep[j] = bits[j + (8 * i)];
    }
    printf("%8s ", byterep);
  }

  printf(")\n");

  return 0;
}
